 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 ' RS232 to 3FDO
 ' Gianni Pallotti, December 2014
 ' 3DFO PWM MMITE-28pins
 ' This program will get 3 Axis outputs from X-SIM program and drive 3 DC motors
 ' visit <http://www.xsimulator.net/> for X-Sim Tools
 ' Interface Output: A<Axis1><Axis2><Axis3>Z
 ' A marks the start and Z marks the end of the transmission
 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

 ' Configuration constants
option autorun on
CPU 48
LCD INIT 10,9,15,16,17,18                                       'allocate display pin out

LCD clear
for a = 16 to 1 step -1
LCD 1,a, "3DFO Program by:"
LCD 1,a+16," "
LCD 2,a, "   GBP - 2015   "
LCD 2,a+16," "
Pause 300 
next a
Pause 1000
LCD 1,1, "   MicroMite    "
LCD 2,1, "waiting for data"
Pause 500
open "COM1:115200:inv" as #1
setpin 23, ain 'M1 pot value input (Pot1)
setpin 24, ain 'M2 pot value input (Pot2)
setPin 25, ain 'M3 pot value input (Pot3)
setpin 2, DOUT 'M1 direction (Mot1Dir)
setpin 3, DOUT 'M2 direction (Mot2Dir)
setpin 26, DOUT 'M3 direction (Mot3Dir)

K1=2                                                          'offset to adjust power-off range min=2 max=5
K2=2
K3=2
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''    
 
 Do                                                           'this is the main program loop, it never exits
   LoadInputs                                                 'get new position records x, y, z 
   
'M1 sequence                  
   Pot1 = fix(pin(23)/3.3*100)*10                             'get M1 pot value and format Pot1 to %
   Mot1 = fix(M1/255*100)*10                                  'format Mot1 to %
   Pot2 = fix(pin(24)/3.3*100)*10                             'get M1 pot value and format Pot1 to %
   Mot2 = fix(M2/255*100)*10                                  'format Mot1 to %
   Pot3 = fix(pin(25)/3.3*100)*10                             'get M1 pot value and format Pot1 to %
   Mot3 = fix(M3/255*100)*10                                  'format Mot1 to %
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     
    if Pot1 < Mot1 then                                       'split Pot1 to 100%-0-100%
       Pin(2) = 1                                             'set clockwise direction
    else
       pin(2) = 0                                             'set unticlockwise direction
    endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     
    if Pot2 < Mot2 then                                       'split Pot2 to 100%-0-100%
       Pin(3) = 1                                             'set clockwise direction
    else
       pin(3) = 0                                             'set unticlockwise direction
    endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     
    if Pot3 < Mot3 then                                       'split Pot3 to 100%-0-100%
       Pin(26) = 1                                            'set clockwise direction
    else
       pin(26) = 0                                            'set unticlockwise direction
    endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''       
   Mot1Hz =abs(Mot1 - Pot1)/5                                'Set on motion Mot1
   if Mot1 <= Pot1 + K1 and Mot1 >= Pot1 - K1 then Mot1Hz=0: endif    'power-off range
   if Mot1Hz > K1 then Mot1Hz = 100 : endif 
   if Mot1Hz > 100 then Mot1Hz = 100 : endif
   if Mot1Hz < K1 then Mot1Hz = 0 : endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''    
   Mot2Hz =ABS(Mot2 - Pot2)/5                                'Set on motion Mot2
   if Mot2 <= Pot2 + K2 and Mot2 >= Pot2 - K2 then Mot2Hz=0 : endif    'power-off range
   if Mot2Hz > K2 then Mot2Hz = 100 : endif 
   if Mot2Hz > 100 then Mot2Hz = 100 : endif
   if Mot2Hz < K2 then Mot2Hz = 0 : endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''       
   Mot3Hz =ABS(Mot3 - Pot3)/5                                'Set on motion Mot3
   if Mot3 <= Pot3 + K3 and Mot3 >= Pot3 - K3 then Mot3Hz=0 : endif    'power-off range
   if Mot3Hz > K3 then Mot3Hz = 100 : endif 
   if Mot3Hz > 100 then Mot3Hz = 100 : endif
   if Mot3Hz < K3 then Mot3Hz = 0 : endif
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''       
    PWM 1,25000, Mot1Hz, Mot2Hz, Mot3Hz  
     LCD 1,1, "xyz: " + str$(Mot1/10,3)+" ": LCD 1,10, str$(Mot2/10,3)+" ": LCD 1,14, str$(Mot3/10,3)
     LCD 2,1, "ABC: " + str$(Pot1/10,3)+" ":lcd 2,10, str$(Pot2/10,3)+" ": LCD 2,14, str$(Pot3/10,3) 
     
Loop
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''    
Sub LoadInputs:                                              'subroutine to get the X-SIM axis position of M1, M2, M3
 DO
   dat$=INPUT$(1,#1)                                         'read 1 character from COM1
     if dat$ = "A" then                                      'Start of Record
       datout$=""
     endif
    if dat$="Z" then                                         'End of Record
       M1=asc(left$(datout$,1))
       M2=asc(mid$(datout$,2,1))
       M3=asc(right$(datout$,1))
      exit sub
    endif
   if dat$<>"A" and dat$<>"Z" then
    datout$=datout$+dat$
   endif
LOOP
end sub
